; Define name of registers
.alias flag 2
.alias flag2 3
.include "HDL50001_pcf.inc"

.text

start:
	jmp timer0
complete

;;;;; Processing timer0 ;;;;;
timer0:
	jmp initTimer0
	setl #flag, 0
	setl #flag2, 4 ;increase time interval in "flag2" times (4 - 1sec, 9 - 2sec)
complete
;; Set counter period and prescaler, allow interrupt processing Timer0
initTimer0:
	jmp StartTimer0
	getl 0x0000FFFF
	wrl @1, TIM0_CNT
	getl 0x0000007A
	wrl @1, TIM0_PSC  ;(10Hz)
complete
;;Start counter and allow interrupt flag from counter, use periodic resume
StartTimer0:
	jmp Timer0Finish
	getl 0x0000001F
	wrl @1, TIM0_CR
complete
;;Wait for timer0 finish
Timer0Finish:
	getl 0x00000010
	rdl TIM0_CR
	and @1, @2
	je @1, Timer0Finish
	jne @2, PortOut
complete
;;Choose (on or off) led on GPIOA
PortOut:
	getl 0x00000010 ;clear bit 4 by write "1"
	rdl TIM0_CR
	and @1, @2
	je @1, clrbit_or
	jne @2, clrbit_rep
complete

clrbit_or:
	rdl TIM0_CR
	getl 0x00000010
	or @1, @2
	wrl @1, TIM0_CR
	getl #flag
	je @1, Ledoff
	jne @2, Ledon
complete

clrbit_rep:
	rdl TIM0_CR
	wrl @1, TIM0_CR
	getl #flag
	je @1, Ledoff
	jne @2, Ledon
complete

;;Led off
Ledoff:
	getl #flag2
	subl @1, 1
	je @2, disable
	jne @3, Timer0Finish
	setl #flag2, @3
complete

; enable led 2,3
enable:
	jmp Timer0Finish
	getl 0x60000000
	wrl @1, GPIOB_DIR
	getl 0x00000000
	wrl @1, GPIOB_OUT
	setl #flag2, 4
	setl #flag, 0	
complete
;;Led on
Ledon:
	getl #flag2
	subl @1, 1
	je @2, enable
	jne @3, Timer0Finish
	setl #flag2, @3
complete

; disable led 2,3
disable:
	jmp Timer0Finish
	getl 0x60000000
	wrl @1, GPIOB_DIR
	getl 0x60000000
	wrl @1, GPIOB_OUT ;set PortB 29,30 pin
	setl #flag2, 4
	setl #flag, 1
complete

