;Constant list
.include "HDL50001_pcf.inc"
;UART varible
.alias DM_START		0x00000000 ;start address DM for output by uart0
.alias BLOCK_SIZE	0x00000800 ;end address DM for output by uart0
.alias iterator1 2
.alias iterator2 3
.alias byte_DM 4
;Counter registers
.alias iterCount 6
.alias lastIterIndex 9
.data

b: .byte 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

.text
start:
	jmp initUSB
	getl 0xFFC40000
	wrl @1, GPIOA_BPS ;allow port alternative functions for usb
complete

initUSB:
	jmp init
	getb 0x00
	wrb @1, USB_HSCR ;enable controller

	getb 0x03 ;enable endpoint and activate it
	wrb @1, USB_EPCR0
	wrb @2, USB_EPCR1
	wrb @3, USB_EPCR2
	wrb @4, USB_EPCR3

	wrb @7, USB_EPNTRST0

	getb 0x01
	wrb @1, USB_EPNTRST1
	wrb @2, USB_EPNTRST2
	wrb @3, USB_EPNTRST3
	wrb @4, USB_MSKINT
	wrb @5, USB_CR
complete

waitForReadyRead:
	rdl USB_STINT
    and @1, 1
	jne @1, readByte
	je @2, waitForReadyRead
complete

init:
	jmp waitForReadyRead
	setl #iterCount, 9 ;numb bytes sent by PC for read
complete

readByte:
	getl #iterCount
	je @1, stop1
	jne @2, readByte

	getl b
	addl @1, @4
	rdl USB_RXDATA0
	wrb @1, @2

	subl @7, 1
	setl  #iterCount, @1
complete

stop1:
	jmp get_disc1
	getb 0x12
	wrb @1, USB_TXDATA0
	getb 0x01
	wrb @1, USB_TXDATA0
	getb 0x10
	wrb @1, USB_TXDATA0
	getb 0x01
	wrb @1, USB_TXDATA0
	getb 0x00
	wrb @1, USB_TXDATA0
	getb 0x00
	wrb @1, USB_TXDATA0
	getb 0x00
	wrb @1, USB_TXDATA0
	getb 0x08
	wrb @1, USB_TXDATA0
	getb 0x00
	wrb @1, USB_TXDATA0
	getb 0x00
	wrb @1, USB_TXDATA0
	getb 0x00
	wrb @1, USB_TXDATA0
	getb 0x00
	wrb @1, USB_TXDATA0
	getb 0x00
	wrb @1, USB_TXDATA0
	getb 0x00
	wrb @1, USB_TXDATA0
	getb 0x00
	wrb @1, USB_TXDATA0
	getb 0x00
	wrb @1, USB_TXDATA0
	getb 0x7B
	wrb @1, USB_TXDATA0
	getb 0x01
	wrb @1, USB_TXDATA0
complete

;receive answer PC after sending descriptor 1
get_disc1:
	jmp waitForReadyRead2
	setl #iterCount, 9
complete

waitForReadyRead2:
	rdl USB_STINT
    and @1, 1
	jne @1, readByte2
	je @2, waitForReadyRead2
complete

readByte2:
	getl #iterCount
	je @1, stop3
	jne @2, readByte2

	getl 0x20
	addl @1, @4
	rdl USB_RXDATA0
	wrb @1, @2 ; write answer PC to DM

	subl @7, 1
	setl  #iterCount, @1
complete

stop3:
	jmp initUART0
complete

;config uart0
initUART0:
	jmp read_DM
	getl 0x00000300
	wrl @1, GPIOB_BPS
	getl 0x00000104
	wrl @1, UART0_BDR
	getl 0x00000003
	wrl @1, UART0_CR
	setl #iterator1, 0x00000000
complete

read_DM:
	getl BLOCK_SIZE
	subl @1, #iterator1
	je @1, stop2
	jne @2, out_DM
	getl #iterator1
	addl @1, DM_START
	rdq @1
	setq #byte_DM, @1
	addl @4, 0x00000008
	setl #iterator1, @1
	setl #iterator2, 0
complete

out_DM:
	getl #iterator2
	getl 56
	subl @1, @2
	je @1, buf_TXD
	jne @2, out_DM
	getq #byte_DM
	slrq @1, #iterator2
	wrq @1, UART0_DATA
	getl 8
	addl @1, #iterator2
	setl #iterator2, @1
complete

buf_TXD:
	rdl UART0_ST
	getl 0x00000004
	and @1, @2
	je @1, buf_TXD
	jne @2, read_DM
complete

stop2:
	getl 0x60000000
	wrl @1, GPIOB_DIR
	getl 0x60000000
	wrl @1, GPIOB_OUT
complete




