//Spi test
#include <HDL51001_ccf.h>
#include <spi.h>
#include <wdt.h>
#include <uart.h>
#include <math.h>

//16 bit word (12 bits data + 4 control bits)

void main(){
    int v_int;
    float value, degree, step, my_func;
    UART_InitTypeDef UART_InitStructure;
    
    UART_InitStructure.BaudRate = 38400; //set baudrate
    UART_InitStructure.TypeParity = 0x00000000; //parity control type
    UART_InitStructure.Parity = 0x00000000; //enable parity control
    UART_InitStructure.FlowControl = 0x00000000; //enable cts/rts
    UART_InitStructure.Mode = 0x00000003; //rx enable - 1 bit, tx enable - 2 bit (rx + tx en)  
        
    uart_init(UART3, &UART_InitStructure);
    
    WDT_OFF;
    step = 0.02;
    
    GPIOD->BPS = 0xF7F; //uart + spi2 alternative port
    SPI_SSEN(SPI2, 1); //  S  SPI2
    SPI2->SS = 0x07; //  CS-DAC   
    SPI2->CR = 0x27F00000; // SPI2
    while(SPI_ST_NF(SPI2) == 0); //   
    SPI2->SS = 0x05; //  CS-DAC   
    SPI2->TX = 0x400B; //      
    while(SPI_ST_TIP(SPI2) == 1); //   
    SPI2->SS = 0x07; //  CS-DAC   
    degree = 0.0;
    value = 0.0;
    
    while(1){
        if(degree > 6.28) degree = 0.0;
        my_func = sinf(degree); //   
        value = (my_func + 1.0)*1000.0; //   TLV5638ID
        v_int = (int)value & 0xFFF; //   float  int
        //*((int*)(512)) = value; //    
        //DM2UART(UART3, (int)&value, 4); //  UART3   value  
        while(SPI_ST_NF(SPI2) == 0); //   
        SPI2->SS = 0x05; //  CS-DAC   
        SPI2->TX = (v_int | 0xC000)<<16; //     SPI2
        while(SPI_ST_TIP(SPI2) == 1); //   
        SPI2->SS = 0x07; //  CS-DAC   
        degree = degree + step; //     
    }
 
    // GPIOD->DIR = ((uint32_t)0x00007000);
    // GPIOD->OUT = ((uint32_t)0x00007000);
}


